//  RTree version 1.4
//  Copyright (C)
//
//  RReport@Confluencia.net
//  All rights reserved
//
// Adquisition , use and distribution of this code is subject to restriction:
//  - You may modify the source code in order to adapt it to your needs.
//  - Redistribution of this ( or a modifed version) source code is prohibited. You may only redistribute compiled versions.
//  - You may not remove this notice from the source code
//  - This notice disclaim all warranties of all material
//
//
package com.java4less.rtree;


import java.awt.*;
import java.applet.*;
import java.util.*;

/**
 * <p>The RTreeApplet is a thin layer on the RTreeList class that allows you to use
  the RTreeList as an applet in a web page. The parameters for the applet are:</p>
<h2>Parameters of the applet&nbsp;</h2>
<p>Allmost all parameters are Strings or Integers, however the are some special
  cases:</p>
<ul>
  <li>Colors: valid values are: RED,BLUE,GREEN,BLACK,GRAY,LIGHTGRAY,WHITE,DARKGRAY,YELLOW,ORANGE,CYAN
    and MAGENTA. You can also use the numerical value of a color as parameter.</li>
  <li>Fonts have the format&nbsp; &lt;font name&gt;|&lt;style&gt;|&lt;size&gt;.
    Style can be PLAIN, ITALIC or BOLD. Example: &quot;Arial|BOLD|12&quot;</li>
</ul>
<p>The parameters of the applet are:</p>
<ul>
  <li><b>NODE_CLICKED_COLOR:</b> color of the node after it has been clicked.
    This will show the page the user is on.</li>
  <li><b>NODE_CLICKED_BACK:</b> backgorund color of the node after it has been
    clicked. </li>
  <li><b>NODE_CLICKED_FONT:</b> font of the node after it has been clicked. </li>
  <li><b>NODE_CLICKED_IMAGE:</b> icon of the node after it has been clicked. </li>
  <li><b>MINUS_ICON</b>: Image used instead of the signed - when the node is expanded.</li>
  <li><b>PLUS_ICON</b>: Image used instead of the signed + when the node is not
    expanded.</li>
  <li><b>SHOW_ROOT:</b> If &quot;Y&quot; then the root of the tree will be displayed,
    it not, it will be hidden.</li>
  <li><b>TREE_ANIMATION:</b> This parameter defines how the initial animation
    is going to be. Valid values are:<br>
    NO: there will be no animation<br>
    TOP: the tree will come from the top a will scroll down.<br>
    BOTTOM: the tree will come from the bottom a will scroll up.<br>
    LEFT: the tree will come from the left a will scroll right.<br>
    RIGHT: the tree will come from the right a will scroll left.</li>
  <li><b>TREE_ANIMATION_DELAY</b>: time in milliseconds between scenes of the
    initial animation.</li>
  <li><b>TREE_AUTOREORGANIZE:</b> if &quot;Y&quot; the tree will be reorganized
    after the uses clicks on a node. This means that only the selected node will
    remain expanded. </li>
  <li><b><font color="#800000">TREE_AUTOREORGANIZE_ALWAYS</font>:</b> if &quot;Y&quot;
    the tree will be reorganized each time the user expands a new node. This means
    that only the selected node will remain expanded. </li>
  <li><b>TREE_BACK_COLOR:</b> background color of the tree.</li>
  <li><b>TREE_BACK_IMAGE:</b> background image for the tree.</li>
  <li><b>TREE_BORDER</b>: type of border. Valir values are: NO,RAISED,LOWERED,LINE,LINE2,SHADOW
    and DOUBLE.</li>
  <li><b>TREE_BORDER_COLOR:</b> color of the border.</li>
  <li><b>TREE_BOX_COLOR:</b> color of the box used to display the tips. The default
    value is BLACK.</li>
  <li><b>TREE_EXPAND_MODE.</b> Valid values are:<br>
    ON_CLICK: a node will be expanded only when the user clicks on it<br>
    ON_ENTER: a node will be automatically expanded when the cursor is on it.&nbsp;</li>
  <li><b>TREE_DRAW_LINE</b>: Valid values are &quot;Y&quot; or &quot;N&quot;.
    If &quot;N&quot; then no lines will be displayed between a node an its children.</li>
  <li><b>TREE_DRAW_PLUS_MINUS</b>: Valid values are &quot;Y&quot; or &quot;N&quot;.
    It &quot;Y&quot; then the tree will display a + sign next to collapsed nodes
    and a - signe next to expanded nodes.</li>
  <li><b>TREE_ICON_WIDTH</b>: width in pixels of the space reserved for the icon.</li>
  <li><b>TREE_ITEM_HEIGHT</b>. Height of the nodes of the tree. The default value
    is 20 (in pixels).</li>
  <li><b>TREE_LOADING_FONT</b>: Font to be used for the text displayed when the
    tree is loading a definition file or images.</li>
  <li><b>TREE_LOADING_IMAGE</b>: Image to be displayed when the tree is loading
    a definition file or images.</li>
  <li><b>TREE_LOADING_TEXT</b>: This is the text to be displayed when the tree
    is loading a definition file or images. The default value is &quot;Loading...&quot;;</li>
  <li><b>TREE_LEFT_MARGIN</b>. In pixels.</li>
  <li><b>TREE_LINE_COLOR:</b> color of the lines in the tree. The default value
    is BLACK.</li>
  <li><b>TREE_LINE_TYPE</b>: This is the type of line used to link a node and
    its children. Valid values as NORMAL, DASHED or DOTS.</li>
  <li><b>TREE_OPEN_TEXT</b>: This is the text to be displayed when the tree is
    opening a link after the user double-clicks a node. The default value is &quot;Opening
    URL...&quot;;</li>
  <li><b>TREE_PAGE_BACK_COLOR</b>: background color of the page where the applet
    is.</li>
  <li><b>TREE_SCROLL_COLOR</b>: background color of the scroll bar.</li>
  <li><b>TREE_STARTUP_NODE: </b>name of the node that will be initially selected.</li>
  <li><b>TREE_TAB: </b>This is the left margin of the children of a node. The
    default value is 20. This means that children will be displayes 10 pixes to
    the right of the parent.</li>
  <li><b>TREE_TARGET</b>: target frame of the HTML page. Valid values are: &quot;_self&quot;,
    &quot;_parent&quot;,&quot;_top&quot;, &quot;_blank&quot; or &lt;frame name&gt;.
    This is the default used if it is not otherwise specified at the node level.</li>
  <li><b>TREE_TIP_BACK_COLOR:</b> background color of the tips. The default value
    is YELLOW.</li>
  <li><b>TREE_TIP_COLOR</b>: text color of the tips.</li>
  <li><b>TREE_TIP_DELAY</b>: This is the number of milliseconds the tree is going
    to wait before showing the tip of the current node.</li>
  <li><b>TREE_TIP_FONT</b>: text font of the tips.</li>
  <li><b>TREE_TOP_MARGIN.</b> In pixels.</li>
</ul>
<p>The following parameters define default values for the nodes:</p>
<ul>
  <li><b>NODE_BACK_COLOR</b>: background color of the node.</li>
  <li><b>NODE_BACK_IMAGE:</b> background image of the nodes.</li>
  <li><b>NODE_BACK_SELECTED_COLOR:</b> background color when the node is selected.</li>
  <li><b>NODE_CENTER_TEXT: </b>center text of the nodes.</li>
  <li><b>NODE_COLOR</b>: color of the texts.</li>
  <li><b>NODE_EXPANDED_ICON</b>: icon when the node is expanded.</li>
  <li><b>NODE_ICON</b>: icon of the node.</li>
  <li><b>NODE_FONT</b>: font of the text..</li>
  <li><b>NODE_RAISED:</b> if &quot;Y&quot; the node will displayed a &quot;raised&quot;
    effect when it is selected.</li>
  <li><b>NODE_SELECTED_COLOR</b>: color of the text when the node is selected.</li>
</ul>
<p>The following parameters define the value for a given node. The * must be substituted
  by the node's name. If the parameters are used in Javascript or in a definition
  file the *_ should not be included:</p>
<ul>
  <li><b>*_BACK_IMAGE</b>: background image of the node.</li>
  <li><b>*_CENTER_TEXT</b>: center text of the node.</li>
  <li><b>*_BACK_COLOR:</b> background color of the node.</li>
  <li><b>*_BACK_SELECTED_COLOR</b>: background color when the node is selected.</li>
  <li><b>*_COLOR:</b> color of the texts.</li>
  <li><b>*_DATA_FILE:</b> file where the definition of the children of this node
    can be found.</li>
  <li><b>*_EXPANDED: </b>Valid values are &quot;Y&quot; or &quot;N&quot;.</li>
  <li><b>*_EXPANDED_ICON</b>: icon when the node is expanded.</li>
  <li><b>*_ICON:</b> icon of the node.</li>
  <li><b>*_FONT:</b> font of the text..</li>
  <li><b>*_LINK</b>: URL to open when the user double-clicks the node.</li>
  <li><b>*_RAISED:</b> if &quot;Y&quot; the node will displayed a &quot;raised&quot;
    effect when it is selected.</li>
  <li><b>*_SELECTED_COLOR</b>: color of the text when the node is selected.</li>
  <li><b>*_TARGET</b>: target frame of the HTML page. Valid values are: &quot;_self&quot;,
    &quot;_parent&quot;,&quot;_top&quot;, &quot;_blank&quot; or &lt;frame name&gt;.</li>
  <li><b>*_TEXT:</b> text for this node (use &quot;\n&quot; to create a new line).</li>
  <li><b>*_TIP</b>: tip for this node (use &quot;\n&quot; to create a new line).</li>
</ul>
<p>&nbsp;</p>
<p>The following parameters will allow you to execute JavaScript functions when
  something happens:</p>
<ul>
  <li><b>TREE_ON_ENTER: </b>This function will be executed when the mouse enters
    the menu. It has no parameters.</li>
  <li><b>TREE_ON_EXIT:</b> This function will be executed when the mouse exits
    the menu. It has no parameters.</li>
  <li><b>TREE_ON_LOAD:</b> This function will be executed applet is loading nodes
    and images.</li>
  <li><b>TREE_ON_LOAD_END:</b> This function will be executed the applet has finished
    loading nodes and images..</li>
  <li><b>TREE_ON_SELECT</b>: This function will be executed when the mouse is
    over a node. The function will receive as parameter, the node's name.</li>
  <li><b>TREE_ON_EXPAND:</b> This function will be executed when the user expands
    a node. The function will receive as parameter, the node's name.</li>
  <li><b>TREE_ON_DBL_CLICK</b>: This function will be executed when the user double-clicks
    a node. The function will receive as parameter, the node's name.</li>
</ul>
<p>See the file Example3.html to see an example of these parameters.&nbsp;</p>
<p>&nbsp;</p>
<h2>Loading from files<br>
</h2>
<p>&nbsp;</p>
<p>The data for a node or tree can also be loaded from a text file instead of
  using the parameters of the applet. The advantadge of this approach is: </p>
<ul>
  <li>You can change the menu in you HTML page without modifing the HTML file.</li>
  <li>The tree's nodes will be loaded dynamically. Only when the node is expanded
    its children will be created.</li>
  <li>In the case of a big menu using parameters would result in a big HTML file.</li>
</ul>
<p>The structure of the file is very simple; <b>each file contains the definition
  of the children of one node only</b>. Each line in the file contains one command.
  The command can be: </p>
<ul>
  <li>CHILD=&lt;new node's name&gt; to create a new child</li>
  <li>&lt;parameter's name&gt;=&lt;parameter's value&gt; to assign a vaue to the
    child.</li>
</ul>
<p>For example:</p>
<blockquote>
  <p><i>CHILD=Index<br>
    ICON=car1.gif<br>
    SELECTED_ICON=car2.gif<br>
    DATA_FILE=file://www.myserver/IndexNodes.txt<br>
    TEXT=Index<br>
    CHILD=Features<br>
    </i>.<br>
    .<br>
    . </p>
</blockquote>
<p>&nbsp;This file creates a new node called &quot;Index&quot;. The following
  4 lines contain some parameters for this node. This parameters have the same
  name as those used in the applet parameters (without the *_). Note that the
  children of the node &quot;index&quot; will be defined in the file &quot;IndexNodes.txt&quot;.</p>
<h2>Javascript </h2>
<p>It is also possible to change teh appearance of the tree from Javascript (See
  the file Example1.html to see an example of this). The following methods can
  be accessed from javascript : </p>
<ul>
  <li><b>clearTree</b> </li>
  <li><b>getNodeProperty</b> </li>
  <li><b>setParam </b></li>
  <li><b>refreshTree</b> </li>
  <li><b>getNodeText</b> </li>
  <li><b>loadNode</b> </li>

</ul>

 */
public class RTreeApplet extends Applet
{

	private final static int LEFT_BORDER=0;
    private final static int TOP_BORDER=2;
	private final static int BOTTOM_BORDER=3;
	private final static int RIGHT_BORDER=4;

	private boolean started=false;
    private boolean inited=false;

	private boolean stopped=false;
	private Thread thread;

	/** tree
         *
         */
	public RTreeList tree = new RTreeList();
	// canvas used to draw the border
    borderCanvas appBorderLeft=new borderCanvas(LEFT_BORDER);
	borderCanvas appBorderRight=new borderCanvas(RIGHT_BORDER);
	borderCanvas appBorderTop=new borderCanvas(TOP_BORDER);
	borderCanvas appBorderBottom=new borderCanvas(BOTTOM_BORDER);

	// border types
        public static final int NO_BORDER=0;
	public static final int BORDER_LINE=1;
	public static final int BORDER_RAISED=2;
	public static final int BORDER_LOWERED=3;
	public static final int BORDER_DOUBLE=4;
	public static final int BORDER_SHADOW=5;
	public static final int BORDER_LINE2=6;

	// size of the border
	private int upperBorder=0;
    private int bottomBorder=0;
	private int leftBorder=0;
	private int rightBorder=0;

	// properties related with the border
        /** type of the border of the applet
         *
         */
	public int borderType=BORDER_LINE;
        /**
         * if you use border type BORDER_SHADOW, this must be the same color as the background of the HTML page
         */
	public Color pageBackColor=java.awt.Color.white;
	public java.awt.Color borderColor=java.awt.Color.black;

	// previous size

	private int previousW=0;
	private int previousH=0;


        /** internal, for Rtree Visual Designer only
         *
         */
	public Panel simulator=null;

	// FUNCTIONS FOR JAVA SCRIPT

	/**
         * <P>Sets a parameter for a node. This methods allows the configuration of
the applet from javascript. For example, in order to change the icon of
a node called &quot;node1&quot;:</P>

<P>javascript:document.tree.setParam('node1','ICON','newicon.gif');</P>

<P>&nbsp;In the example &quot;tree&quot; is the name of the applet.
         */
	public void setParam(String nodeName,String Param,String Value) {

	 RNode n=null;
	 if (nodeName.length()>0)  n=tree.findNode(tree.Root,nodeName);

	 if ((nodeName.length()==0)|| (n!=null)) tree.processParameter(n,Param.toUpperCase(),Value);

	}

	// clear tree
	public void clearTree(String nodeName) {
	 RNode n=null;

	 if (nodeName.length()>0) n=tree.findNode(tree.Root,nodeName);

	 if (n==null) n=tree.Root;

	 tree.clear(n);

	 // collapse and expand root to update nodes
	 tree.expandNode(tree.Root.Name,false);
	 tree.expandNode(tree.Root.Name,true);
	 tree.refresh();

	}

/**
 *  return node's text
 */
	public String getNodeText(String nodeName) {

	     RNode n=null;
	     if (nodeName.length()>0) n=tree.findNode(tree.Root,nodeName);

	     if (n==null) return "";

		 return n.getText();
	}


// return node's tip text
	public String getNodeTip(String nodeName) {

	     RNode n=null;
	     if (nodeName.length()>0) n=tree.findNode(tree.Root,nodeName);

	     if (n==null) return "";

		 return n.tipText;
	}

	// return node's parent
	public String getNodeParent(String nodeName) {

	     RNode n=null;
	     if (nodeName.length()>0) n=tree.findNode(tree.Root,nodeName);

	     if (n==null) return "";

		 if (n.parent==null) return "";

		 return n.parent.Name;
	}

/**
 * <PRE>
returns the property of the node. Supported properties are:</PRE>

<UL>
<LI>&quot;EXPANDED&quot;: return &quot;Y&quot; or &quot;N&quot;. This can
be used to store the state of the nodes in javascript so that by reloading
the tree can be &quot;reconstructed&quot;.&nbsp;</LI>
</UL>


 */
	public String getNodeProperty(String nodeName,String sParam) {

	     RNode n=null;
	     if (nodeName.length()>0) n=tree.findNode(tree.Root,nodeName);

	     if (n==null) return "";

		 if (sParam.toUpperCase().compareTo("EXPANDED")==0) {
			if (n.expanded) return "Y";
			else return "N";
		 }

		 return "";

	}

	public void setBounds(int x1,int y1,int w, int h) {

		super.setBounds(x1,y1,w,h);

		if ((w!=this.previousW) || (h!=this.previousH)) {
            this.resizeTree();
			if (started) {
                this.doLayout();
				this.printComponents(this.getGraphics());
				tree.refresh();
			}
        }
	}


	/**
         * loads the children of the node <I>nodename</I> from the file <I>sFile</I>.
         */
	public void loadNode(String nodeName,String sFile) {

	 // detele before loading new data
	 clearTree(nodeName);



	 RNode n=null;
	 if (nodeName.length()>0) n=tree.findNode(tree.Root,nodeName);

	 if (n==null) n=tree.Root;

	 n.childrenDefinitionFile=sFile;
	 tree.createTreeFromFile(n,sFile);
	 // collapse and expand root to update nodes
	 tree.expandNode(tree.Root.Name,false);
	 tree.expandNode(tree.Root.Name,true);
	 tree.refresh();

	}

/**repaints the tree. The Javascript should call this after using other functions in other methods.
 *
 */
	public void refreshTree() {
		tree.refresh();
	}

	// END OF FUNCTIONS FOR JAVA SCRIPT

	public void resizeTree() {

        if (!inited) return;

		  // size of the scroll area depends on the border's size
		  calculateBorderSize();

		  // for canvas for the border
		  if (leftBorder>0) {
			  appBorderLeft.setBounds(0,upperBorder,leftBorder,this.getSize().height-bottomBorder-upperBorder);

		  }
		  if (rightBorder>0) {
			  appBorderRight.setBounds(this.getSize().width-rightBorder,upperBorder,rightBorder,this.getSize().height-bottomBorder-upperBorder);

		  }
		  if (upperBorder>0) {
			  appBorderTop.setBounds(0,0,this.getSize().width,upperBorder);

		  }
		  if (bottomBorder>0) {
			  appBorderBottom.setBounds(0,this.getSize().height-bottomBorder,this.getSize().width,bottomBorder);

		  }

          setBorderBackground();

		  int treeW=this.getSize().width-rightBorder-leftBorder;
		  int treeH=this.getSize().height-upperBorder-bottomBorder;
		  tree.itemWidth=0;

		  tree.setBounds(leftBorder,upperBorder,treeW,treeH);



	}



	public void init() {

		  if (started) return;

		  stopped=false;
		  System.out.println("init");


		  Container area=simulator;

		  if (area==null) area=(Container) this;


		  // set the applet of the tree
		  tree.parentApplet=this;

		   // read parameters for the applet itself , border
	 	  String param;
		  param=getStringParam("TREE_PAGE_BACK_COLOR","WHITE");
		  if (param.length()>0) pageBackColor=tree.convertColor(param);
		  param=getStringParam("TREE_BORDER_COLOR","BLACK");
		  if (param.length()>0) borderColor=tree.convertColor(param);

		  // text and image to show while loading
		  param=getStringParam("TREE_LOADING_TEXT","");
		  if (param.length()>0)
			  tree.loadingText=param;
		  param=getStringParam("TREE_LOADING_COLOR","");
		  if (param.length()>0)
			  tree.loadingColor=tree.convertColor(param);
		  param=getStringParam("TREE_LOADING_FONT","");
		  if (param.length()>0) tree.loadingFont=tree.convertFont(param);
		  param=getStringParam("TREE_LOADING_IMAGE","");
		  if (param.length()>0) tree.loadingImage=tree.loadImageUrl(param);

		  param=getStringParam("TREE_BORDER","");
		  if (param.length()>0) {
			 if (param.compareTo("NO")==0) borderType=NO_BORDER;
			 if (param.compareTo("RAISED")==0) borderType=BORDER_RAISED;
			 if (param.compareTo("LINE")==0) borderType=BORDER_LINE;
			 if (param.compareTo("LINE2")==0) borderType=BORDER_LINE2;
			 if (param.compareTo("LOWERED")==0) borderType=BORDER_LOWERED;
			 if (param.compareTo("SHADOW")==0) borderType=BORDER_SHADOW;
			 if (param.compareTo("DOUBLE")==0) borderType=BORDER_DOUBLE;
		  }

                  inited=true;

		  this.setLayout(null);


		  this.resizeTree();

		  if (leftBorder>0) {
			  area.add(appBorderLeft);
		  }
		  if (rightBorder>0) {
			  area.add(appBorderRight);
		  }
		  if (upperBorder>0) {
			  area.add(appBorderTop);
		  }
		  if (bottomBorder>0) {
			  area.add(appBorderBottom);
		  }


		  area.add(tree);

	}

	public void stop() {
		stopped=true;
		started=false;
		System.out.println("stopping");
		thread.stop();
	}

	public void start() {

		if (stopped) init();

		if (started) return;
		started=true;

		System.out.println("starting");
		// start tree (this starts the initial animation)
		thread=new Thread(tree);
		thread.start();
	}



	protected String getStringParam(String Param,String def) {

      return this.getParameter(Param, def);

    }


  //Get a parameter value
  private String getParameter(String key, String def) {


	if (simulator!=null) return def;

    if (getParameter(key) != null) return getParameter(key) ;
    else return def;
  }



  // the color of the canvas are used to simulate the border
  public void setBorderBackground() {

     if ((borderType==BORDER_LINE)|| (borderType==BORDER_LINE2)) {
		   appBorderLeft.setBackground(borderColor);
		   appBorderTop.setBackground(borderColor);
		   appBorderBottom.setBackground(borderColor);
		   appBorderRight.setBackground(borderColor);
	   }

	   if (borderType==BORDER_LOWERED)  {

		   appBorderLeft.setBackground(java.awt.Color.darkGray);
		   appBorderTop.setBackground(java.awt.Color.darkGray);
		   appBorderBottom.setBackground(java.awt.Color.white);
		   appBorderRight.setBackground(java.awt.Color.white);
	   }

	   if ((borderType==BORDER_RAISED) || (borderType==BORDER_DOUBLE)) {
		   appBorderBottom.setBackground(java.awt.Color.darkGray);
		   appBorderRight.setBackground(java.awt.Color.darkGray);
		   appBorderTop.setBackground(java.awt.Color.white);
		   appBorderLeft.setBackground(java.awt.Color.white);
	   }


	   if (borderType==BORDER_DOUBLE) {

		   appBorderBottom.setBackground(borderColor);
		   appBorderRight.setBackground(borderColor);
		   appBorderTop.setBackground(borderColor);
		   appBorderLeft.setBackground(borderColor);

		}
  }


	  // calculate size of the canvas used to simulate the border
	private void calculateBorderSize() {

	   if ((borderType==BORDER_LINE)|| (borderType==BORDER_LINE2)) {
		   upperBorder=1;
		   leftBorder=1;
		   bottomBorder=1;
		   rightBorder=1;
		   if (borderType==BORDER_LINE2) {
		     upperBorder=2;
		     leftBorder=2;
		     bottomBorder=2;
		     rightBorder=2;
		   }
	   }

	   if (borderType==BORDER_LOWERED)  {
		   upperBorder=1;
		   leftBorder=1;
		   bottomBorder=1;
		   rightBorder=1;
	   }

	   if ((borderType==BORDER_RAISED) || (borderType==BORDER_DOUBLE)) {
		   upperBorder=1;
		   leftBorder=1;
		   bottomBorder=1;
		   rightBorder=1;
	   }

	   if (borderType==BORDER_DOUBLE) {
		   upperBorder=4;
		   leftBorder=4;
		   bottomBorder=4;
		   rightBorder=4;
	   }

	    if (borderType==BORDER_SHADOW) {
		   upperBorder=0;
		   leftBorder=0;
		   bottomBorder=4;
		   rightBorder=4;
		}

	}


	// Border class
	public class borderCanvas  extends Canvas {

	int borderSide=0;

	public borderCanvas(int side) {
		 borderSide=side;

	}

	public void paint(Graphics g) {




	   if (borderType==BORDER_DOUBLE) {

		   if (borderSide==TOP_BORDER) {
		     // upper
			 g.setColor(java.awt.Color.white);
		     g.drawLine(0,0,this.getSize().width,0);
			 g.setColor(java.awt.Color.darkGray);
			 g.drawLine(3,3,this.getSize().width-4,3);

			 // left border segment
			 g.setColor(java.awt.Color.white);
			 g.drawLine(0,0,0,this.getSize().height);
			 // right border segment
			 g.setColor(java.awt.Color.darkGray);
			 g.drawLine(this.getSize().width-1,0,this.getSize().width-1,this.getSize().height);

		   }

		   // left
		   if (borderSide==LEFT_BORDER) {
		     g.setColor(java.awt.Color.darkGray);
		     g.drawLine(3,0,3,this.getSize().height);
			 g.setColor(java.awt.Color.white);
			 g.drawLine(0,0,0,this.getSize().height);


		   }

		   // right
		   if (borderSide==RIGHT_BORDER) {

			 g.setColor(java.awt.Color.white);
			 g.drawLine(this.getSize().width-4,0,this.getSize().width-4,this.getSize().height);
		     g.setColor(java.awt.Color.darkGray);
		     g.drawLine(this.getSize().width-1,0,this.getSize().width-1,this.getSize().height);
		   }

		   // bottom
		   if (borderSide==BOTTOM_BORDER) {
			 g.setColor(java.awt.Color.white);
			 g.drawLine(3,0,this.getSize().width-4,0);
		     g.setColor(java.awt.Color.darkGray);
		     g.drawLine(0,this.getSize().height-1,this.getSize().width,this.getSize().height-1);

			 // left border segment
			 g.setColor(java.awt.Color.white);
			 g.drawLine(0,0,0,this.getSize().height);
			 // right border segment
			 g.setColor(java.awt.Color.darkGray);
			 g.drawLine(this.getSize().width-1,0,this.getSize().width-1,this.getSize().height);
		   }
	   }

	    if (borderType==BORDER_SHADOW) {

			if (borderSide==BOTTOM_BORDER) {

  			  g.setColor(pageBackColor);
			  // simulate page backgorund
		      // bottom
		      g.fillRect(0,0,6,4);
			  g.setColor(java.awt.Color.darkGray);
		      // bottom
		      g.fillRect(6,0,this.getSize().width-6,4);

			}

			if (borderSide==RIGHT_BORDER) {

		      // right
		     g=appBorderRight.getGraphics();
		     g.setColor(pageBackColor);
		     g.fillRect(0,0,4,6);
		     g.setColor(java.awt.Color.darkGray);
		      // right
		     g.fillRect(0,6,4,appBorderRight.getSize().height);

			}

		}

		}

	}

}
